const app = getApp()
import $http from './../../API/http'
import create from 'dd-store'
import exampleStore from '/stores/exampleStore'
create.Page({
  store: exampleStore,
  useAll: true,
  data: {
    startTimeYear: '', // 开始时间的年月日
    startTimeHour: '', // 开始时间的时分
    endTimeYear: '', // 结束时间的年月日
    endTimeHour: '', // 结束时间的时分
    startTime: '', // 完整的开始时间
    endTime: '', // 完整的结束时间
    purpose: '', //来访目的完整的信息
    purposes: [], // 所有的来访目的
    currentPurpose: '', // 当前选择的来访目的
    isInput: false, // 来访目的是否需要手动输入
    arriveAddress: [], // 来访的地址
    defaultAddress: '', // 选中的来访地址
    Companions: [],
    copyPerson: [], // 周知人
    index: '',
    visitorPhone: '',// 主访客的手机号
    visitorCompany: '',// 访客的单位
    visitorPurpose: '', // 访客手动输入的目的
    visitorNode: '',// 访客的备注
    isPackUp: false // 是否收起更多消息
  },
  onLoad(query) {
    this.reSet()
    dd.setNavigationBar({
      title: '预约访客'
    });
    this.Purpose()
    this.arriveAddress()
  },
  // 重置事件
  reSet() {
    console.log('djjj')
    const _that = this
    _that.setData({
      startTimeYear: '', // 开始时间的年月日
      startTimeHour: '', // 开始时间的时分
      endTimeYear: '', // 结束时间的年月日
      endTimeHour: '', // 结束时间的时分
      startTime: '', // 完整的开始时间
      endTime: '', // 完整的结束时间
      purpose: '', //来访目的完整的信息
      purposes: [], // 所有的来访目的
      currentPurpose: '', // 当前选择的来访目的
      isInput: false, // 来访目的是否需要手动输入
      arriveAddress: [], // 来访的地址
      defaultAddress: '', // 选中的来访地址
      Companions: [],
      copyPerson: [], // 周知人
      index: '',
      visitorPhone: '',// 主访客的手机号
      visitorCompany: '',// 访客的单位
      visitorPurpose: '', // 访客手动输入的目的
      visitorNode: '',// 访客的备注
      isPackUp: false // 是否收起更多消息
    })
    _that.store.data.visitorName = '',
      _that.store.data.selectVisitors = false,
      _that.store.data.visitorPeer = [],
      _that.update()
    let startTimeYear = this.timeToStr(new Date()).yearMonthDate
    let startTimeHour = this.timeToStr(new Date()).hourMinute
    let endTimeYear = this.timeToStr(new Date()).yearMonthDate
    let endTimeHour = this.timeToStr(new Date()).hourMinute
    let startTime = this.timeToStr(new Date())
    let endTime = this.timeToStr(new Date())
    this.setData({
      startTimeYear: startTimeYear,
      startTimeHour: startTimeHour,
      endTimeYear: endTimeYear,
      endTimeHour: `24:00`,
      startTime: `${startTime.year}-${startTime.month}-${startTime.date} ${startTime.hour}:${startTime.minute}`,
      endTime: `${startTime.year}-${startTime.month}-${startTime.date} 24:00`
    })
  },
  //本页面input输入事件
  visitorInput(event) {
    const _that = this
    switch (event.currentTarget.dataset.type) {
      case "visitorName":
        _that.store.data.visitorName = event.detail.value
        _that.update()
        break;
      case "visitorPhone":
        _that.setData({ visitorPhone: event.detail.value })
        break;
      case "visitorCompany":
        _that.setData({ visitorCompany: event.detail.value })
        break;
      case "visitorPurpose":
        _that.setData({ visitorPurpose: event.detail.value })
        break;
      case "visitorPeerName":
        console.log(_that.store.data.visitorPeer[event.currentTarget.dataset.index - 1])
        _that.store.data.visitorPeer[event.currentTarget.dataset.index - 1].name = event.detail.value
        _that.store.data.visitorPeer[event.currentTarget.dataset.index - 1].index = event.currentTarget.dataset.index

        _that.update
        break;
      case "visitorPeerPhone":
        _that.store.data.visitorPeer[event.currentTarget.dataset.index - 1].phone = event.detail.value
        _that.store.data.visitorPeer[event.currentTarget.dataset.index - 1].index = event.currentTarget.dataset.index
        _that.update
        break;
      case "visitorNode":
        _that.setData({ visitorNode: event.detail.value })
        break;
      default:

        break;
    }
  },
  // 点击通讯录选择访客 控制遮照层出
  selectVisitors(event) {
    this.setData({ index: event.target.dataset.index })
    this.store.data.selectVisitors = true
    this.update()
  },
  // 取消遮照层
  selectCancel() {
    this.store.data.selectVisitors = false
    this.update()
  },
  // 点击外部联系人
  externalContactSelect(event) {
    dd.navigateTo({ url: `./../externalContact/externalContact?index=${this.data.index}` });
  },
  // 点击手机通讯录
  phoneAddressBookSelect() {
    dd.navigateTo({ url: `./../phoneAddressBook/phoneAddressBook?index=${this.data.index}` });
  },
  // 添加同行人员
  addCompanions() {
    if (this.store.data.visitorPeer.length < 4) {
      this.store.data.visitorPeer.push({ name: '', index: '', phone: '' })
      console.log(this.store.data.visitorPeer)
      this.update()
    } else {
      dd.alert({
        content: '最多可添加四名同行人员',
        buttonText: '确定'
      })
    }
  },
  // 收起更多消息
  isPackUp() {
    if (this.data.isPackUp == false) {
      this.setData({ isPackUp: true })
    }
    else {
      this.setData({ isPackUp: false })
    }

  },
  // 关闭同行访客
  closeVisitor(event) {
    this.store.data.visitorPeer.splice(event.target.dataset.index, 1)
    this.update()
  },
  // 删除周知人
  deleateCcPeople(event) {
    this.data.copyPerson.splice(event.target.dataset.index, 1)
    this.setData({ copyPerson: this.data.copyPerson })
  },
  // 周知人
  copyPerson() {
    const _that = this
    console.log(_that.data.copyPerson.length)
    if (_that.data.copyPerson.length <= 5) {
      dd.complexChoose({
        title: "选择周知人",            //标题
        multiple: false,            //是否多选
        responseUserOnly: true,        //返回人，或者返回人和部门
        success: function(res) {
          console.log(res, 'copyPerson')
          res.users.forEach((item, index) => {
            _that.data.copyPerson.push(item)
          })
          _that.setData({
            copyPerson: _that.duplicateRemoval(_that.data.copyPerson)
          })
        },
        fail: function(err) {
          console.log(err, 'copyPerson')
        }
      })

    }
    else {
      dd.alert({
        content: '最多可选取6人',
        buttonText: '确定'
      })
    }
  },
  // 周知人去重
  duplicateRemoval(person) {
    let obj = {};
    let peon = person.reduce((cur, next) => {
      obj[next.userId] ? "" : obj[next.userId] = true && cur.push(next);
      return cur;
    }, [])
    return peon
  },
  // 提交预约单
  confirmAppointment() {
    const _that = this
    // _that.formValidation()
    let participator = ''
    _that.data.copyPerson.forEach((item, index) => {
      participator = participator + item.userId + ','
    })
    participator = participator.substring(0, participator.length - 1)

    let visitorPeer = ''
    _that.store.data.visitorPeer.forEach((item, index) => {
      visitorPeer = visitorPeer + item.name + ':' + item.phone + ','
    })
    visitorPeer = visitorPeer.substring(0, visitorPeer.length - 1)

    let purpose = ''
    if (this.data.currentPurpose == '其他') {
      purpose = this.data.visitorPurpose
    }
    else {
      purpose = this.data.currentPurpose
    }
    let data = {
      startTime: this.data.startTime + '' + ':00',
      endTime: this.data.endTime + '' + ':00',
      visitorInfo: `${this.store.data.visitorName}:${this.data.visitorPhone},${visitorPeer}`,
      companyName: this.data.visitorCompany,
      purpose: purpose,
      visitorPurpose: this.data.visitorPurpose,
      visitAddress: this.data.defaultAddress,
      visitorNode: this.data.visitorNode,
      participator: participator
    }
    $http.$http('/admin/visitor/addRecord', data, 'post').then(res => {
      dd.alert({
        content: '预约成功',
        buttonText: '确定',
        success: () => {
          dd.redirectTo({
            url: '/pages/visitors/visitors'
          })
        },
      });
    }).catch(err => {
      console.log(err)
    })
  },
  // 表单验证
  formValidation() {
    if (this.store.data.visitorName == '' || this.store.data.visitorName.length > 20) {
      dd.alert({ content: '访客姓名不能为空且长度小于20个字符', buttonText: '确定' })
      return
    }
    else if (this.data.visitorPhone == '' || !(/^[1][3,4,5,7,8][0-9]{9}$/).test(this.data.visitorPhone)) {
      dd.alert({ content: '请输入正确的手机号码', buttonText: '确定' })
      return
    }
    else if (this.data.visitorCompany.length > 20) {
      dd.alert({ content: '访客单位的长度小于20个字符', buttonText: '确定' })
      return
    }
    else if (new Date(this.data.startTime).getTime() < new Date(this.data.endTime)) {
      dd.alert({ content: '开始时间不能晚于结束时间', buttonText: '确定' })
      return
    }
    else if (this.data.visitorPurpose.length > 20) {
      dd.alert({ content: '来访目的的长度小于20个字符', buttonText: '确定' })
      return
    }
  },
  // 选择开始时间
  selectStartTime() {
    dd.datePicker({
      format: 'yyyy-MM-dd HH:mm',
      success: (res => {
        let time = this.timeToStr(res.date)
        console.log(time)
        this.setData({
          startTimeYear: `${time.yearMonthDate}`,
          startTimeHour: `${time.hourMinute}`,
          startTime: `${res.date}`
        })
      })
    })
  },
  // 选择结束时间
  selectEndTime() {
    dd.datePicker({
      format: 'yyyy-MM-dd HH:mm',
      success: (res => {
        let time = this.timeToStr(res.date)
        console.log(res.date)
        this.setData({
          endTimeYear: `${time.yearMonthDate}`,
          endTimeHour: `${time.hourMinute}`,
          endTime: `${res.date}`
        })
      })
    })

  },
  // 选择来访目的
  selectPurpose(event) {
    console.log(this.data.purpose, 'selectPurpose')
    this.setData({
      currentPurpose: this.data.purpose[event.detail.value].visitPurpose
    })
    this.isInput()
  },
  // 选择地址
  selectAddress(event) {
    console.log(event)
    console.log(this.data.arriveAddress[event.detail.value].address, 'this.data.arriveAddress[event.detail.value].address')
    this.setData({
      defaultAddress: this.data.arriveAddress[event.detail.value]
    })
  },
  // 所有的到访地址
  arriveAddress() {
    $http.$http('/admin/address/list', {}, 'get').then(res => {
      console.log(res, 'arriveAddress')
      let arriveAddress = []
      res.forEach((item, index) => {
        arriveAddress.push(item.address)
        if (item.isDefault == '0') {
          this.setData({ defaultAddress: item.address })
        }
      })
      if (this.data.defaultAddress == '') {
        this.setData({ defaultAddress: arriveAddress[0] })
      }
      this.setData({ arriveAddress: arriveAddress })
    })
  },
  // 所有的来访的目的
  Purpose() {
    $http.$http('/admin/visit-purpose/list', {}, 'post').then(res => {
      console.log(res, 'Purpose')
      let purposes = []
      res.forEach((item, index) => {
        purposes.push(item.visitPurpose)
      })
      this.setData({
        purpose: res,
        purposes: purposes,
        currentPurpose: res[1].visitPurpose,
      })
    })
  },
  // 处理时间
  timeToStr(time) {
    if (/-/.test(time)) {
      time = time.replace(/\-/g, "/")
    }
    let timeData = new Date(time)
    let year = timeData.getFullYear()
    let month = timeData.getMonth() + 1
    let date = timeData.getDate()
    let hour = timeData.getHours()
    let minute = timeData.getMinutes()
    return {
      year: year,
      month: month.toString().length > 1 ? month : '0' + month,
      date: date.toString().length > 1 ? date : '0' + date,
      hour: hour.toString().length > 1 ? hour : '0' + hour,
      minute: minute.toString().length > 1 ? minute : '0' + minute,
      yearMonthDate: `${year}年${month.toString().length > 1 ? month : '0' + month}月${date.toString().length > 1 ? date : '0' + date}日`,
      hourMinute: `${hour.toString().length > 1 ? hour : '0' + hour}时${minute.toString().length > 1 ? minute : '0' + minute}分`,
      allTime: `${year}年${month.toString().length > 1 ? month : '0' + month}月${date.toString().length > 1 ? date : '0' + date}日 ${hour.toString().length > 1 ? hour : '0' + hour}:${minute.toString().length > 1 ? minute : '0' + minute}分`
    }
  },
  // 是否展示到访目的的输入框
  isInput() {
    if (this.data.currentPurpose != '其他') {
      this.setData({
        isInput: false
      })
    }
    else {
      this.setData({
        isInput: true
      })

    }
  },
  test() {

  },
  onReady() {

  },
  onShow() {
    // 页面显示
    // 关闭遮照层
    this.store.data.selectVisitors = false
    this.update()
  },
  onHide() {
    // 页面隐藏
  },
  onUnload() {
    // 页面被关闭
  },
  onTitleClick() {
    // 标题被点击
  },
  onReachBottom() {
  },
  onShareAppMessage() {
    // 返回自定义分享信息
    return {
      title: 'My App',
      desc: 'My App description',
      path: 'pages/index/index',
    };
  },
});
